var bvqx = BrainVoyager;//BrainVoyagerQX;
var $find = bvqx.FindChild;
var $setfloat = bvqx.SetPluginFloatParameter;
var $setint = bvqx.SetPluginIntParameter;
var $setstring = bvqx.SetPluginStringParameter;
var $getstring = bvqx.GetPluginStringParameter;

var o = new Object;
o.dialogFileName    = "MoCoPro.ui";
o.dialogAccessName  = "PluginDialog";


o.initDlg = function()
{
   $find("pb_StartDisplacement").clicked.connect(this, this.displacement);
   $find("pb_StartConfound").clicked.connect(this, this.confound);
   $find("pb_BrowseSDM").clicked.connect(this, this.browse);
   
   var sample_path = bvqx.PathToSampleData;
   var html_index = sample_path.replace("SampleData/", "Extensions/Plugins_64/MoCoProHelp/CreateConfoundSDMs.html");
   var html_file =  "file:///".concat(html_index);
   $find("txtbr_confound").source = new QUrl(html_file);
   
   sample_path = bvqx.PathToSampleData;
   html_index = sample_path.replace("SampleData/", "Extensions/Plugins_64/MoCoProHelp/DisplacementMaps.html");
   html_file =  "file:///".concat(html_index);
   $find("txtbr_displacement").source = new QUrl(html_file);
}

o.commonStart = function()
{
  if (!$find("le_3DMCfile").text){
    bvqx.MessageBox("You have to select a _3DMC.sdm before you can start");
    this.browse(); 
  }
  $setstring("sdmfile", $find("le_3DMCfile").text);
  $setint("plot_regular", $find("chb_plotreg").checked);
  $setint("plot_detrended", $find("chb_plotdetr").checked);
}


o.displacement = function()
{
    this.commonStart();
    $setfloat("fmr_threshold", $find("spBox_FRMTH").value);
    $setint("map_max_abs", $find("chb_MaxAbs").checked);
    $setint("map_mean_abs", $find("chb_MeanAbs").checked);
    $setint("map_max_rel", $find("chb_MaxRel").checked);
    $setint("map_mean_rel", $find("chb_MeanRel").checked);
    $setint("map_max_abs_x", $find("chb_MaxAbsX").checked);
    $setint("map_max_abs_y", $find("chb_MaxAbsY").checked);
    $setint("map_max_abs_z", $find("chb_MaxAbsZ").checked);
      
    $setstring("task", "displacement");
    this.PluginDialog.close();
    bvqx.ExecutePlugin();
}


o.confound = function()
{
    this.commonStart();
    $setfloat("spike_threshold", $find("spBox_SpikeTH").value);
    $setint("create_detrended", $find("chb_detr").checked);
    $setint("create_derivative", $find("chb_deriv").checked);
    $setint("create_spikes", $find("chb_spk").checked);
    $setint("create_squared", $find("chb_sq").checked);
    $setint("create_delayed1", $find("chb_t1").checked);
    $setint("create_delayed1sq", $find("chb_t1sq").checked);
    $setint("create_delayed2", $find("chb_t2").checked);
    $setint("create_delayed2sq", $find("chb_t2sq").checked);
    $setint("create_drms", $find("chb_rms").checked);

    $setstring("task", "confound");
    this.PluginDialog.close();
    bvqx.ExecutePlugin();
}


o.browse = function()
{
    $setstring("task", "select_3dmcsdm");
    bvqx.ExecutePlugin();
    var filename = $getstring("sdmfile");
    if (filename)
        $find("le_3DMCfile").text = filename;
}


o;
